﻿using Bogus;
using System;
using System.Collections.Generic;

using VV.Wrappers.SqlServer.Core.Tests.Comum.Entities;

namespace VV.Wrappers.SqlServer.Core.Tests.Comum.Faker
{
    internal static class GeneratePersonFaker
    {
        public static PersonTest CreatePersonObjectFaker()
        {
            var person = new Faker<PersonTest>("pt_BR")
               .RuleFor(c => c.Id, f => f.Random.Int())
               .RuleFor(c => c.Name, f => f.Name.FirstName())
               .RuleFor(c => c.Surname, f => f.Name.LastName())
               .Generate();

            return person;
        }

        public static IEnumerable<PersonTest> CreateListPersonObjectFaker(int countGenerate)
        {
            var person = new Faker<PersonTest>("pt_BR")
               .RuleFor(c => c.Id, f => f.Random.Int())
               .RuleFor(c => c.Name, f => f.Name.FirstName())
               .RuleFor(c => c.Surname, f => f.Name.LastName())
               .Generate(countGenerate);

            return person;
        }
    }
}
