﻿namespace VV.Wrappers.SqlServer.Core.Base.Entities
{
    public abstract class EntityBase<T> : EntityBase where T : struct
    {
        public T Id { get; protected set; }

        public override bool Equals(object obj)
        {
            var compareTo = obj as EntityBase<T>;

            if (ReferenceEquals(this, compareTo))
                return true;
            if (ReferenceEquals(null, compareTo))
                return false;

            return Id.Equals(compareTo.Id);
        }

        public override int GetHashCode()
        {
            return GetType().GetHashCode() * 907 + Id.GetHashCode();
        }
    }

    public abstract class EntityBase { }
}
