﻿using Microsoft.Extensions.DependencyInjection;

using System.Data;
using System.Data.SqlClient;

using VV.Wrappers.SqlServer.Core.Dapper.Uow;
using VV.Wrappers.SqlServer.Core.Dapper.Uow.Interfaces;
using VV.Wrappers.SqlServer.Core.Dapper.Uow.Transacations;

namespace VV.Wrappers.SqlServer.Core.Dapper.Configurations
{
    public static class DapperConfigurationsExtensions
    {
        public static IServiceCollection AddDapperSqlServer(this IServiceCollection service, string connectionString)
        {
            service.AddScoped<IDbConnection>(db => new SqlConnection(connectionString));
            service.AddScoped<IDapperUnitOfWork, DapperUnitOfWork>();
            service.AddScoped<ITransactionBase, TransactionBase>();

            return service;
        }
    }
}
