﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using VV.Wrappers.SqlServer.Core.Base.Entities;

namespace VV.Wrappers.SqlServer.Core.Dapper.Repositories.Interfaces
{
    public interface IRepositoryDapperBase<TEntity, TKey> : IDisposable
        where TEntity : EntityBase<TKey>
        where TKey : struct
    {
        Task InsertAsync(TEntity entity);
        Task UpdateAsync(TEntity entity);
        Task DeleteAsync(TKey id);
        Task<TEntity> GetByIdAsync(TKey id);
        Task<IEnumerable<TEntity>> GetAllAsync();
    }
}
