﻿using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using System.Threading.Tasks;

using VV.Wrappers.SqlServer.Core.Base.Entities;

namespace VV.Wrappers.SqlServer.Core.EF.Repositories.Interfaces
{
    public interface IRepositoryEFBase<TEntity, TKey> : IDisposable
        where TEntity : EntityBase<TKey>
        where TKey : struct
    {
        Task InsertAsync(TEntity entity);
        Task<TEntity> UpdateAsync(TEntity entity);
        Task DeleteAsync(TEntity entity);
        Task<TEntity> GetByIdAsync(TKey id);
        Task<IEnumerable<TEntity>> GetAllAsync(Expression<Func<TEntity, bool>> where);
    }
}
